/********************************************************************************
* Copyright (c) Erik Kunze 1995 - 1999
*
* Permission to use, distribute, and sell this software and its documentation
* for any purpose is hereby granted without fee, provided that the above
* copyright notice appear in all copies and that both that copyright notice and
* this permission notice appear in supporting documentation, and that the name
* of the copyright holder not be used in advertising or publicity pertaining to
* distribution of the software without specific, written prior permission.  The
* copyright holder makes no representations about the suitability of this
* software for any purpose.  It is provided "as is" without express or implied
* warranty. THE CODE MAY NOT BE MODIFIED OR REUSED WITHOUT PERMISSION!
*
* THE COPYRIGHT HOLDER DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
* INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO
* EVENT SHALL THE COPYRIGHT HOLDER BE LIABLE FOR ANY SPECIAL, INDIRECT OR
* CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE,
* DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER
* TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
* PERFORMANCE OF THIS SOFTWARE.
*
* Author: Erik Kunze
*******************************************************************************/
#ifdef HAVE_CONFIG_H
# include "config.h"
#endif
#ifndef lint
static char rcsid[] = "$Id: vtp.c,v 1.1 1999/05/23 09:01:17 erik Rel $";
#endif
#include <assert.h>
#include "dialog.h"
#include "loadsave.h"
#include "vtp.h"
#define PAGE_SIZE		17U
static void vtpDisplayPage(unsigned int);
void
VtpInit(void)
{
}
void
VtpNewInputFile(void)
{
}
void
VtpNewOutputFile(void)
{
}
void
VtpUpdate(void)
{
}
void
VtpBrowser(void)
{
unsigned int item;
int oldInDialog;
assert(TpState & (TS_TAPIN | TS_TZXIN));
oldInDialog = EnterOSD();
{
const char *selectorText[PAGE_SIZE + 2];
int i;
selectorText[0] = "Browse Inputfile";
for (i = 1; i <= NOPTS(selectorText); i++)
{
selectorText[i] = " ";
}
selectorText[i] = NULL;
DisplayMenu(selectorText);
}
item = TpInBlockCurrent;
vtpDisplayPage(item / PAGE_SIZE);
for (;;)
{
switch ((int)BrowseList(&item, TpInBlockCount, PAGE_SIZE,
vtpDisplayPage))
{
case XK_Return:
TpInBlockCurrent = item;
if (item == TpInBlockCount - 1)
{
TpState |= TS_ENDIN;
}
else
{
TpState &= ~TS_ENDIN;
}
case XK_Escape:
goto quit;
}
}
quit:
LeaveOSD(oldInDialog);
}
static void
vtpDisplayPage(unsigned int page)
{
unsigned int cnt;
uns8 cursor_y = MENU_CURSOR_Y;
TapeRecord *tr;
uns8 attr = GetAttr();
SetAttr(MENU_SELECT_ATTR);
SetCursor(MENU_CURSOR_X + 1, cursor_y);
DrawBox(COLS - 2 * (MENU_CURSOR_X + 1), PAGE_SIZE);
for (cnt = page * PAGE_SIZE;
cnt < (page + 1) * PAGE_SIZE && cnt < TpInBlockCount;
cnt++)
{
tr = (TapeRecord *)RetrieveElemList(TpInBlockList, cnt);
assert(tr !=  NULL);
if (cnt == TpInBlockCurrent)
{
SetAttr(MENU_DISABLED_ATTR);
PrintString(tr->str);
SetAttr(MENU_SELECT_ATTR);
}
else
{
PrintString(tr->str);
}
SetCursor(MENU_CURSOR_X + 1, ++cursor_y);
}
SetAttr(attr);
}
